﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;
using System.Threading.Tasks;
using Windows.UI.Xaml;
using System.ComponentModel;

namespace SfProgressBar_NewSample
{
   public class Model : INotifyPropertyChanged
    {

        DispatcherTimer timer;

        private double value1 = 0.0;
        public double Value1
        {
            get { return value1; }
            set
            {
                value1 = value;
               NotifyPropertyChanged("Value1");
            }
        }

       

        private TimeSpan interval = TimeSpan.FromSeconds(0.01);
        public TimeSpan Interval
        {
            get { return interval; }
            set
            {
                interval = value;
                timer.Interval = interval;
               NotifyPropertyChanged("Interval");
            }
        }

        private ICommand start;
        public ICommand Start
        {
            get { return new DelegateCommand<object>(StartProgress, args => true); }
            set { start = value; NotifyPropertyChanged("Start"); }
        }

        private ICommand pause;
        public ICommand Pause
        {
            get { return new DelegateCommand<object>(PauseProgress, args => true); }
            set { pause = value; NotifyPropertyChanged("Pause"); }
        }

        
        private ICommand resume;

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        public ICommand Resume
        {
            get { return new DelegateCommand<object>(ResumeProgress, args => true); }
            set { resume = value; NotifyPropertyChanged("Resume"); }
        }


        public Model()
        {
            timer = new DispatcherTimer() { Interval = Interval };
            timer.Tick += Timer_Tick;
            timer.Start();
        }

        private void Timer_Tick(object sender, object e)
        {
            TimerTick(timer);
        }

        private void TimerTick(object param)
        {
              Value1 += 1.0;
        }

        private void StartProgress(object param)
        {
            timer.Stop();
            Value1 = 25.0;
            timer.Interval = TimeSpan.FromSeconds(0.02);
            timer.Start();
        }
        private void PauseProgress(object param)
        {
            timer.Stop();
        }
        private void ResumeProgress(object param)
        {
            timer.Start();
        }

        internal void Dispose()
        {
            timer.Stop();
            timer.Tick -= Timer_Tick;
            timer = null;
        }

    }

   
}
